/**
 * This file creates custom elements used on the admin.html page.
 * 
 * The admin.html file uses classes such as login-inner but also uses them as HTML elements,
 * which is technically illegal unless they are defined as HTML5 custom elements.
 * This file formally defines the elements per HTML5 requirements.
 * 
 * See: https://developer.mozilla.org/en-US/docs/Web/Web_Components/Using_custom_elements
 * 
 * @author: Mike Hewett
 * @since: 2019-01-02
 */

// The customElements entries are at the bottom

class KSAvailableVersionElement extends HTMLElement {
	constructor() {
		super();
	}
}

class KSIdentityProviderConfiguredElement extends HTMLElement {
	constructor() {
		super();
	}
}

class KSIdentityProviderHeadElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSIdentityProviderInnerSectionElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSIdentityProviderNotConfiguredElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSListTermsRowElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoggedInElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginBodyElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginBoxElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginBoxInnerElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginButtonElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginFooterElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginInitializeElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginInnerElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginLogoElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginPasswordElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginRegionElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginUsernameElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginVersionElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSLoginWarningElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSNotLoggedInElement extends HTMLElement {
    constructor() {
        super();
    }
}

/*
 * HTML5 does not let you redefine "path".
 */
/*
class KSPathElement extends HTMLElement {
    constructor() {
        super();
    }
}
 */

class KSRightPanelElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSRightPanelConfigurationElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSRightPanelStatusElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSServiceProviderConfiguredElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSServiceProviderHeadElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSServiceProviderNotConfiguredElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSSideBarElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSSidebarFootElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSSidebarInnerElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSSidebarNavElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSStatusServiceProviderElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSStatusServiceProviderInnerSectionElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSTwoFactorDialogElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSTwoFactorChannelDialogElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSDeviceApprovalDialogElement extends HTMLElement {
    constructor() {
        super();
    }
}

class KSDeviceApprovalChannelDialogElement extends HTMLElement {
    constructor() {
        super();
    }
}

// KSC-249: 2/2019: Don't declare custom elements on IE or Edge because they don't support custom  elements yet.

// Use the platform.js library to figure out the browser.
// https://github.com/bestiejs/platform.js
var browserName = platform.name;

if ((browserName === "IE") || (browserName === "Microsoft Edge") || (browserName === "IE Mobile") || (typeof customElements === "undefined")) {
	// Don't load customElements because they aren't supported on MS browsers.
	// Note: Edge is planning to support them some day but IE won't.
	console.log("Not loading custom elements")
} else {
	customElements.define("available-version", KSAvailableVersionElement);
    customElements.define("device-approval-dialog", KSDeviceApprovalDialogElement);
    customElements.define("device-approval-channel-dialog", KSDeviceApprovalChannelDialogElement);
	customElements.define("identity-provider-configured", KSIdentityProviderConfiguredElement);
	customElements.define("identity-provider-head", KSIdentityProviderHeadElement);
	customElements.define("identity-provider-inner-section", KSIdentityProviderInnerSectionElement);
	customElements.define("identity-provider-not-configured", KSIdentityProviderNotConfiguredElement);
	customElements.define("list-terms-row", KSListTermsRowElement);
	customElements.define("logged-in", KSLoggedInElement);
	customElements.define("login-body", KSLoginBodyElement);
	customElements.define("login-box", KSLoginBoxElement);
	customElements.define("login-box-inner", KSLoginBoxInnerElement);
	customElements.define("login-button", KSLoginButtonElement);
	customElements.define("login-footer", KSLoginFooterElement);
	customElements.define("login-initialize", KSLoginInitializeElement);
	customElements.define("login-inner", KSLoginInnerElement);
	customElements.define("login-logo", KSLoginLogoElement);
    customElements.define("login-password", KSLoginPasswordElement);
    customElements.define("login-region", KSLoginRegionElement);
	customElements.define("login-username", KSLoginUsernameElement);
	customElements.define("login-version", KSLoginVersionElement);
	customElements.define("login-warning", KSLoginWarningElement);
	customElements.define("not-logged-in", KSNotLoggedInElement);
//	customElements.define("path", KSPathElement);
	customElements.define("right-panel", KSRightPanelElement);
	customElements.define("right-panel-configuration", KSRightPanelConfigurationElement);
	customElements.define("right-panel-status", KSRightPanelStatusElement);
	customElements.define("service-provider-configured", KSServiceProviderConfiguredElement);
	customElements.define("service-provider-head", KSServiceProviderHeadElement);
	customElements.define("service-provider-not-configured", KSServiceProviderNotConfiguredElement);
	customElements.define("side-bar", KSSideBarElement);
	customElements.define("sidebar-foot", KSSidebarFootElement);
	customElements.define("sidebar-inner", KSSidebarInnerElement);
	customElements.define("sidebar-nav", KSSidebarNavElement);
	customElements.define("status-service-provider", KSStatusServiceProviderElement);
	customElements.define("status-service-provider-inner-section", KSStatusServiceProviderInnerSectionElement);
    customElements.define("two-factor-dialog", KSTwoFactorDialogElement);
    customElements.define("two-factor-channel-dialog", KSTwoFactorChannelDialogElement);
}